/* -*-C-*- */

/*
 *    Copyright (c) 1994, Andreas Koenig <k@franz.ww.TU-Berlin.DE>
 *    Date written: Sep 5, 1994
 *    Released for use with perl5b1 and mSQL0.2 after patch 1
 *
 *    You may distribute under the same terms as Perl5.
 * 
 *    I very much appreciate any feedback!
 */
   
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "msql.h"

typedef int SysRet;
typedef m_result *Msql__Result;
typedef HV *Msql__Statement;
typedef HV *Msql;

#define dMINIMSQL				\
  HV *          hv;				\
  HV *          stash;				\
  SV *          rv;				\
  SV *          sv;				\
  SV *          svsock;				\
  SV *          svdb;				\
  SV *          svhost;				\
  char * 	name = "Msql::db_errstr"

#define dMSQL					\
  dMINIMSQL;					\
  Msql__Result	result = NULL;			\
  SV *		old;				\
  SV **		svp;				\
  char *	package = "Msql::Statement";	\
  char *	interdb;			\
  char *	interhost;			\
  int		sock

#define dMSQLFETCH		\
  dMSQL;			\
  int		off;		\
  m_field *	curField;	\
  m_row		cur


#define dMSQLSTATE		\
  dMSQL;			\
  AV *		avkey;		\
  AV *		avnam;		\
  AV *		avnnl;		\
  AV *		avtab;		\
  AV *		avtyp;		\
  int		off = 0;	\
  m_field *	curField

#define ERRMSG				\
    sv = perl_get_sv(name,TRUE);	\
    sv_setpv(sv,msqlErrMsg);		\
    if (dowarn)				\
      warn("MSQL's message: %s", msqlErrMsg);	\
    ST(0) = sv_newmortal()

#define HANDLE_SOCK				\
  if (svp = hv_fetch(handle,"SOCK",4,FALSE)){	\
    old = *svp;					\
    sock = (int)SvIV(old);			\
    svsock = (SV*)newSViv(sock);		\
  } else {					\
    croak("Could not read svp");		\
  }						\
  if (svp = hv_fetch(handle,"DATABASE",8,TRUE)){	\
    old = *svp;					\
    interdb = (char *)SvPV(old,na);		\
    svdb = (SV*)newSVpv(interdb, strlen(interdb));	\
  } else {					\
    croak("Could not read svp");		\
  }						\
  if (svp = hv_fetch(handle,"HOST",4,TRUE)){	\
    old = *svp;					\
    interhost = (char *)SvPV(old,na);		\
    svhost = (SV*)newSVpv(interhost, strlen(interhost));	\
  } else {					\
    croak("Could not read svp");		\
  }

#define HANDLE_RESULT				\
  if (svp = hv_fetch(handle,"RESULT",6,FALSE)){	\
    sv = *svp;				\
    result = (Msql__Result)SvIV(sv);	\
  } else {					\
    croak("couldn't read svp");		\
  }

#define retMSQLSOCK						\
    hv_store(hv,"SOCK",4,svsock,0);				\
    hv_store(hv,"HOST",4,svhost,0);				\
    hv_store(hv,"DATABASE",8,svdb,0);				\
    rv = newRV((SV*)hv);					\
    stash = gv_stashpv(package, TRUE);                          \
    ST(0) = sv_2mortal(sv_bless(rv, stash))

#define retMSQLRESULT						\
    hv_store(hv,"RESULT",6,(SV *)newSViv((IV)result),0);	\
    retMSQLSOCK

#define my_iniHV 	hv = (HV*)sv_2mortal((SV*)newHV())

#define fetchMSQLINTERN	\
    hv_store(hv,"NUMROWS",7,(SV *)newSViv((IV)msqlNumRows(result)),0);	\
    hv_store(hv,"NUMFIELDS",9,(SV *)newSViv((IV)msqlNumFields(result)),0);	\
    avnam = (AV*)(SV*)newAV();	\
    avtab = (AV*)(SV*)newAV();	\
    avtyp = (AV*)(SV*)newAV();	\
    avkey = (AV*)(SV*)newAV();	\
    avnnl = (AV*)(SV*)newAV();	\
    msqlFieldSeek(result,0);	\
    while (off< msqlNumFields(result)) {	\
      curField = msqlFetchField(result);	\
      av_push(avnam,(SV*)newSVpv(curField->name,strlen(curField->name)));	\
      av_push(avtab,(SV*)newSVpv(curField->table,strlen(curField->table)));	\
      av_push(avtyp,(SV*)newSViv(curField->type));	\
      av_push(avkey,(SV*)newSViv(IS_PRI_KEY(curField->flags)));	\
      av_push(avnnl,(SV*)newSViv(IS_NOT_NULL(curField->flags)));	\
      off++;	\
    }	\
    rv = newRV((SV*)avnam); hv_store(hv,"NAME",4,rv,0);	\
    rv = newRV((SV*)avtab); hv_store(hv,"TABLE",5,rv,0);	\
    rv = newRV((SV*)avtyp); hv_store(hv,"TYPE",4,rv,0);	\
    rv = newRV((SV*)avkey); hv_store(hv,"IS_PRI_KEY",10,rv,0);	\
    rv = newRV((SV*)avnnl); hv_store(hv,"IS_NOT_NULL",11,rv,0)


static int
not_here(s)
char *s;
{
    croak("Msql::%s not implemented on this architecture", s);
    return -1;
}

static double
constant(name, arg)
char *name;
int arg;
{
    errno = 0;
    switch (*name) {
    case 'A':
	break;
    case 'B':
	break;
    case 'C':
	if (strEQ(name, "CHAR_TYPE"))
#ifdef CHAR_TYPE
	    return CHAR_TYPE;
#else
	    goto not_there;
#endif
	break;
    case 'D':
	break;
    case 'E':
	break;
    case 'F':
	break;
    case 'G':
	break;
    case 'H':
	break;
    case 'I':
	if (strEQ(name, "INT_TYPE"))
#ifdef INT_TYPE
	    return INT_TYPE;
#else
	    goto not_there;
#endif
	break;
    case 'J':
	break;
    case 'K':
	break;
    case 'L':
	break;
    case 'M':
	break;
    case 'N':
	if (strEQ(name, "NOT_NULL_FLAG"))
#ifdef NOT_NULL_FLAG
	    return NOT_NULL_FLAG;
#else
	    goto not_there;
#endif
	break;
    case 'O':
	break;
    case 'P':
	if (strEQ(name, "PRI_KEY_FLAG"))
#ifdef PRI_KEY_FLAG
	    return PRI_KEY_FLAG;
#else
	    goto not_there;
#endif
	break;
    case 'Q':
	break;
    case 'R':
	if (strEQ(name, "REAL_TYPE"))
#ifdef REAL_TYPE
	    return REAL_TYPE;
#else
	    goto not_there;
#endif
	break;
    case 'S':
	break;
    case 'T':
	break;
    case 'U':
	break;
    case 'V':
	break;
    case 'W':
	break;
    case 'X':
	break;
    case 'Y':
	break;
    case 'Z':
	break;
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}


XS(XS_Msql__Statement_msqlFetchRow)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Msql::Statement::FetchRow(handle)");
    }
    SP -= items;
    {
	Msql__Statement	handle;

	if (sv_isa(ST(0), "Msql::Statement"))
	    handle = (HV*)SvRV(ST(0));
	else
	    croak("handle is not of type Msql::Statement");
{
/* This one is very simple, it just returns us an array of the fields
   of a row. If we want to know more about the fields, we look into
   $sth->{XXX}, where XXX may be one of NAME, TABLE, TYPE, IS_PRI_KEY,
   and IS_NOT_NULL */

  dMSQLFETCH;
  int		placeholder = 1;

  HANDLE_RESULT;
  if (result && (cur = msqlFetchRow(result))) {
    off = 0;
    msqlFieldSeek(result,0);
    if ( msqlNumFields(result) > 0 )
      placeholder = msqlNumFields(result);
    while(off < placeholder){
      EXTEND(sp,1);
      curField = msqlFetchField(result);

      /* It's still under consideration, what will happen, if a field
	 is NULL. Maybe we'll have to add an if(){} here */

      PUSHs(sv_2mortal((SV*)newSVpv(cur[off], strlen(cur[off]))));
      off++;
    }
  }
}
	PUTBACK;
	return;
    }
}

XS(XS_Msql__Statement_msqlDataSeek)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Msql::Statement::DataSeek(handle,pos)");
    }
    {
	Msql__Statement	handle;
	int	pos = (int)SvIV(ST(1));

	if (sv_isa(ST(0), "Msql::Statement"))
	    handle = (HV*)SvRV(ST(0));
	else
	    croak("handle is not of type Msql::Statement");
{
/* In my eyes, we don't need that, but as it's there we implement it,
   of course: set the position of the cursor to a specified record
   number. */

  Msql__Result	result = NULL;
  SV *		sv;
  SV **		svp;

  HANDLE_RESULT;
  if (result)
    msqlDataSeek(result,pos);
  else
    croak("Could not DataSeek, no result handle found");
}
    }
    XSRETURN(1);
}

XS(XS_Msql__Statement_msqlDESTROY)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Msql::Statement::DESTROY(handle)");
    }
    {
	Msql__Statement	handle;

	if (sv_isa(ST(0), "Msql::Statement"))
	    handle = (HV*)SvRV(ST(0));
	else
	    croak("handle is not of type Msql::Statement");
{
/* We have to free memory, when a handle is not used anymore */

  Msql__Result	result = NULL;
  SV *		sv;
  SV **		svp;

  HANDLE_RESULT;
  if (result){
    msqlFreeResult(result);
/*    warn("Msql::Statement -- Result freed: %lx", result); */
  } else {
/*    warn("Msql.xs: Could not free some result"); */
  }
}
    }
    XSRETURN(1);
}

XS(XS_Msql_constant)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Msql::constant(name,arg)");
    }
    {
	char *	name = (char *)SvPV(ST(0),na);
	int	arg = (int)SvIV(ST(1));
	double	RETVAL;

	RETVAL = constant(name, arg);
	ST(0) = sv_newmortal();
	sv_setnv(ST(0), (double)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Msql_msqlConnect)
{
    dXSARGS;
    if (items < 0 || items > 3) {
	croak("Usage: Msql::Connect(package = \"Msql\",host=NULL,db=NULL)");
    }
    {
	char *	package;
	char *	host;
	char *	db;

	if (items < 1)
	    package = "Msql";
	else {
	    package = (char *)SvPV(ST(0),na);
	}

	if (items < 2)
	    host = NULL;
	else {
	    host = (char *)SvPV(ST(1),na);
	}

	if (items < 3)
	    db = NULL;
	else {
	    db = (char *)SvPV(ST(2),na);
	}
{
/* As we may have multiple simultaneous sessions with more than one
   connect, we bless an object, as soon as a connection is established
   by Msql->Connect(host, db). The object is a hash, where we put the
   socket returned by msqlConnect under the key "SOCK".  An extra
   argument may be given to select the databse we are going to access
   with this handle. As soon as a database is selected, we add it to
   the hash table in the key DATABASE. */

  dMINIMSQL;
  int           sock = msqlConnect(host);

  if ((sock == -1) || (db && (msqlSelectDB(sock,db) == -1))) {
    ERRMSG;  
  } else {
    my_iniHV;
    svsock = (SV*)newSViv(sock);
    svdb = (SV*)newSVpv(db,na);
    svhost = (SV*)newSVpv(host,strlen(host));
    retMSQLSOCK;
  }
}
    }
    XSRETURN(1);
}

XS(XS_Msql_msqlSelectDB)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Msql::SelectDB(handle, db)");
    }
    {
	Msql	handle;
	char *	db = (char *)SvPV(ST(1),na);
	SysRet	RETVAL;

	if (sv_isa(ST(0), "Msql"))
	    handle = (HV*)SvRV(ST(0));
	else
	    croak("handle is not of type Msql");
{
/* This routine does not return an object, it just sets a database
   within the connection. */

  dMSQL;

  HANDLE_SOCK;
  if (sock && db)
    RETVAL = msqlSelectDB(sock,db);
  else
    RETVAL = -1;
  if (RETVAL == -1){
    ERRMSG;
  } else {
    hv_store(handle,"DATABASE",8,(SV*)newSVpv(db,na),0);
  }
}
	ST(0) = sv_newmortal();
	if (RETVAL != -1) {
	    if (RETVAL == 0)
		sv_setpvn(ST(0), "0 but true", 10);
	    else
		sv_setiv(ST(0), (IV)RETVAL);
	}
    }
    XSRETURN(1);
}

XS(XS_Msql_msqlQuery)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Msql::Query(handle, query)");
    }
    {
	Msql	handle;
	char *	query = (char *)SvPV(ST(1),na);

	if (sv_isa(ST(0), "Msql"))
	    handle = (HV*)SvRV(ST(0));
	else
	    croak("handle is not of type Msql");
{
/* A successful query returns a statement handle in the
   Msql::Statement class. In that class we have a FetchRow() method,
   that returns us one row after the other. We may repeat the fetching
   of rows beginning with an arbitrary row number after we reset the
   position-pointer with DataSeek().

   We do a lot here: we investigate some info about the fields, that
   will be returned by this handle: NAME, TABLE, TYPE, IS_PRI_KEY, and
   IS_NOT_NULL */

  dMSQLSTATE;
  int           tmp = -1;

  HANDLE_SOCK;
  if (sock)
    tmp = msqlQuery(sock,query);
  if (tmp == -1 ) {
    ERRMSG;
  } else {
    my_iniHV;
    if ( result = msqlStoreResult() ) { 
      fetchMSQLINTERN;
    }
    retMSQLRESULT;
  }
}
    }
    XSRETURN(1);
}

XS(XS_Msql_msqlListDBs)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Msql::ListDBs(handle)");
    }
    SP -= items;
    {
	Msql	handle;

	if (sv_isa(ST(0), "Msql"))
	    handle = (HV*)SvRV(ST(0));
	else
	    croak("handle is not of type Msql");
{
/* We return an array, of course. */

  dMSQLFETCH;

  HANDLE_SOCK;
  if (sock)
    result = msqlListDBs(sock);
  if (result == NULL ) {
    ERRMSG;
  } else {
    while ( cur = msqlFetchRow(result) ){
      EXTEND(sp,1);
      curField = msqlFetchField(result);
      PUSHs(sv_2mortal((SV*)newSVpv(cur[0], strlen(cur[0]))));
    }
    msqlFreeResult(result);
  }
}
	PUTBACK;
	return;
    }
}

XS(XS_Msql_msqlListTables)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Msql::ListTables(handle)");
    }
    SP -= items;
    {
	Msql	handle;

	if (sv_isa(ST(0), "Msql"))
	    handle = (HV*)SvRV(ST(0));
	else
	    croak("handle is not of type Msql");
{
/* We return an array, of course. */

  dMSQLFETCH;

  HANDLE_SOCK;
  if (sock)
    result = msqlListTables(sock);
  if (result == NULL ) {
    ERRMSG;
  } else {
    while ( cur = msqlFetchRow(result) ){
      EXTEND(sp,1);
      curField = msqlFetchField(result);
      PUSHs(sv_2mortal((SV*)newSVpv(cur[0], strlen(cur[0]))));
    }
    msqlFreeResult(result);
  }
}
	PUTBACK;
	return;
    }
}

XS(XS_Msql_msqlListFields)
{
    dXSARGS;
    if (items != 2) {
	croak("Usage: Msql::ListFields(handle, table)");
    }
    {
	Msql	handle;
	char *	table = (char *)SvPV(ST(1),na);

	if (sv_isa(ST(0), "Msql"))
	    handle = (HV*)SvRV(ST(0));
	else
	    croak("handle is not of type Msql");
{
/* This is similar to a query with 0 rows in the result. Unlike with
   the query we are guaranteed by the API to have field information
   where we also have it after a successful query. That means, we find
   no result with FetchRow, but we have a ref to a filled Hash with
   NAME, TABLE, TYPE, IS_PRI_KEY, and IS_NOT_NULL. We do bless into
   msqlStatement, so DESTROY will free the query. */

  dMSQLSTATE;

  HANDLE_SOCK;
  if (sock && table)
    result = msqlListFields(sock,table);
  if (result == NULL ) {
    ERRMSG;
  } else {
    my_iniHV;
    fetchMSQLINTERN;
    retMSQLRESULT;
  }
}
    }
    XSRETURN(1);
}

XS(XS_Msql_msqlDESTROY)
{
    dXSARGS;
    if (items != 1) {
	croak("Usage: Msql::DESTROY(handle)");
    }
    {
	Msql	handle;

	if (sv_isa(ST(0), "Msql"))
	    handle = (HV*)SvRV(ST(0));
	else
	    croak("handle is not of type Msql");
{
/* Somebody has freed the object that keeps us connected with the
   database, so we have to tell the server, that we are done. */

  dMSQL;

  HANDLE_SOCK;
  if (sock){
    msqlClose(sock);
/*    warn("Msql -- Closed: %d", sock); */
  } else {
/*    warn("Could not Close, no sock found"); */
  }
}
    }
    XSRETURN(1);
}

XS(boot_Msql)
{
    dXSARGS;
    char* file = __FILE__;

    newXS("Msql::Statement::FetchRow", XS_Msql__Statement_msqlFetchRow, file);
    newXS("Msql::Statement::DataSeek", XS_Msql__Statement_msqlDataSeek, file);
    newXS("Msql::Statement::DESTROY", XS_Msql__Statement_msqlDESTROY, file);
    newXS("Msql::constant", XS_Msql_constant, file);
    newXS("Msql::Connect", XS_Msql_msqlConnect, file);
    newXS("Msql::SelectDB", XS_Msql_msqlSelectDB, file);
    newXS("Msql::Query", XS_Msql_msqlQuery, file);
    newXS("Msql::ListDBs", XS_Msql_msqlListDBs, file);
    newXS("Msql::ListTables", XS_Msql_msqlListTables, file);
    newXS("Msql::ListFields", XS_Msql_msqlListFields, file);
    newXS("Msql::DESTROY", XS_Msql_msqlDESTROY, file);
    ST(0) = &sv_yes;
    XSRETURN(1);
}
